<?php
/*
Plugin Name: Cyr-To-Lat
Plugin URI: http://wordpress.org/extend/plugins/cyr2lat/
Description: This plugin converts Cyrillic characters in post taxonomy to Latin characters. Useful for creating human-readable URLs. Thanks to Alexander Shilyaev for the idea and to Anton Skorobogatov for the implementation.
Author: Sol
Author URI: http://ru.wordpress.org/
Version: 2.0
*/ 

function sanitize_term_translate ($title) {
	$cyr2lat_table = array(
	   "Ґ"=>"G","Ё"=>"YO","Є"=>"E","Ї"=>"YI","І"=>"I",
	   "і"=>"i","ґ"=>"g","ё"=>"yo","№"=>"#","є"=>"e",
	   "ї"=>"yi","А"=>"A","Б"=>"B","В"=>"V","Г"=>"G",
	   "Д"=>"D","Е"=>"E","Ж"=>"ZH","З"=>"Z","И"=>"I",
	   "Й"=>"Y","К"=>"K","Л"=>"L","М"=>"M","Н"=>"N",
	   "О"=>"O","П"=>"P","Р"=>"R","С"=>"S","Т"=>"T",
	   "У"=>"U","Ф"=>"F","Х"=>"H","Ц"=>"TS","Ч"=>"CH",
	   "Ш"=>"SH","Щ"=>"SCH","Ъ"=>"'","Ы"=>"YI","Ь"=>"",
	   "Э"=>"E","Ю"=>"YU","Я"=>"YA","а"=>"a","б"=>"b",
	   "в"=>"v","г"=>"g","д"=>"d","е"=>"e","ж"=>"zh",
	   "з"=>"z","и"=>"i","й"=>"y","к"=>"k","л"=>"l",
	   "м"=>"m","н"=>"n","о"=>"o","п"=>"p","р"=>"r",
	   "с"=>"s","т"=>"t","у"=>"u","ф"=>"f","х"=>"h",
	   "ц"=>"ts","ч"=>"ch","ш"=>"sh","щ"=>"sch","ъ"=>"'",
		"ы"=>"yi","ь"=>"","э"=>"e","ю"=>"yu","я"=>"ya"
	);
	
	global $wpdb;
	if ($term = $wpdb->get_var("SELECT slug FROM $wpdb->terms WHERE name='$title'")) return $term; else return strtr($title,$cyr2lat_table);
}

add_action('sanitize_title', 'sanitize_term_translate', 0);
?>
